uniform vec3 lightPosition[3];
uniform vec3 cameraPosition;

attribute float in_height;

varying vec3 worldPos;
varying vec3 eyeDir;
varying vec3 lightDir[3];
varying vec3 normal;
varying float height;
			
void main() 
{
	gl_TexCoord[0] = gl_MultiTexCoord0;
    height = in_height;
				
	vec3 pos = vec3(gl_Vertex);
	gl_Position = ftransform();
				
	eyeDir = normalize( cameraPosition.xyz - pos.xyz );
    for(int i=0; i<3; ++i){
	    lightDir[i] = normalize( lightPosition[i].xyz - pos.xyz );
    }
	worldPos = pos;
				
	normal = normalize(gl_Normal);				
}