#pragma once
#include "PrecompiledHeaders.h"

typedef struct CTwBar TwBar;
using namespace std;

namespace cinder {

    namespace params {

        typedef std::shared_ptr<class CallbackMenu>	CallbackMenuRef;

        class CallbackMenu : public ci::params::InterfaceGl{
        public:
            CallbackMenu() : InterfaceGl() {};
            CallbackMenu( const std::string &title, const Vec2i &size, const ColorA &color = ColorA( 0.3f, 0.3f, 0.3f, 0.4f ) ) : 
                InterfaceGl(title, size, color) {};
            CallbackMenu( cinder::app::WindowRef window, const std::string &title, const Vec2i &size, const ColorA &color = ColorA( 0.3f, 0.3f, 0.3f, 0.4f ) ) :
                InterfaceGl(window, title, size, color) {};

            static CallbackMenuRef create( const std::string &title, const Vec2i &size, const ColorA &color = ColorA( 0.3f, 0.3f, 0.3f, 0.4f ) );
            static CallbackMenuRef create( cinder::app::WindowRef window, const std::string &title, const Vec2i &size, const ColorA &color = ColorA( 0.3f, 0.3f, 0.3f, 0.4f ) );

            void	addParam( const std::string &name, bool *boolParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, float *floatParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, double *doubleParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, int32_t *intParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, Vec3f *vectorParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, Quatf *quatParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, Color *quatParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, ColorA *quatParam, const std::string &optionsStr = "", bool readOnly = false );
            void	addParam( const std::string &name, std::string *strParam, const std::string &optionsStr = "", bool readOnly = false );

            void	addParam( const std::string &name, const std::vector<std::string> &enumNames, int *param, const std::string &optionsStr = "", bool readOnly = false );

            void	addParam( const std::string &name, const std::function<void (bool)> &setter, const std::function<bool ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (float)> &setter, const std::function<float ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (double)> &setter, const std::function<double ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (int32_t)> &setter, const std::function<int32_t ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (Vec3f)> &setter, const std::function<Vec3f ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (Quatf)> &setter, const std::function<Quatf ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (Color)> &setter, const std::function<Color ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (ColorA)> &setter, const std::function<ColorA ()> &getter, const std::string &optionsStr = "" );
            void	addParam( const std::string &name, const std::function<void (std::string)> &setter, const std::function<std::string ()> &getter, const std::string &optionsStr = "" );


            //   void	addParam( const std::string &name, bool *boolParam, const std::function<void (bool)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, float *floatParam, const std::function<void (float)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, double *doubleParam, const std::function<void (double)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, int32_t *intParam, const std::function<void (int32_t)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, Vec3f *vectorParam, const std::function<void (Vec3f)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, Quatf *quatParam, const std::function<void (Quatf)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, Color *quatParam, const std::function<void (Color)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, ColorA *quatParam, const std::function<void (ColorA)> &event, const std::string &optionsStr = "", bool readOnly = false );
            //void	addParam( const std::string &name, std::string *strParam, const std::function<void (std::string)> &event, const std::string &optionsStr = "", bool readOnly = false );

        protected:
            template <class T>
            void implAddParamCb( const std::string &name, int type, const std::string &optionsStr, const std::function<void (T)> &setter, const std::function<T ()> &getter );

            std::list<boost::any>			mStoredCallbacks;
        };

    }
}