#pragma once
#include "PrecompiledHeaders.h"

class GlobalPhysics
{
public:
	GlobalPhysics();
	~GlobalPhysics();

	void addRigidBody(btRigidBody *rigidBody);
	void removeRigidBody(btRigidBody *rigidBody);
	void addConstraint(btTypedConstraint *constraint);
	void removeConstraint(btTypedConstraint *constraint);
	void advance(float dt);

	// ball
	void ballReset();

    btCollisionShape* mBallShape;
    btRigidBody* mBallRigidBody;
    btDefaultMotionState* mBallMotionState;
    btVector3 mBallIntertia;
    btScalar mBallMass;
	
private:
	btBroadphaseInterface* mBroadphase;
	btDefaultCollisionConfiguration* mCollisionConfiguration;
    btCollisionDispatcher* mDispatcher;
	btSequentialImpulseConstraintSolver* mSolver;
	btDiscreteDynamicsWorld* mDynamicsWorld;
};

