#pragma once
#include "PrecompiledHeaders.h"

#include "GlobalPhysics.h"

class Hair {
public:
	Hair(const btVector3 &origin, const btQuaternion &orientation, GlobalPhysics *physicsEngine, float inRadius, float inHeight);
	Hair(Hair&& other);
	Hair(const Hair& other);
	~Hair();

	static const int SEGMENT_COUNT = 5;
	static const int CONSTRAINT_COUNT = SEGMENT_COUNT - 1;
	static float segmentMass;

	// size of each node
	float radius;
	float height;
	// position and orientation of the first (static) node
	btVector3 m_origin;
	btQuaternion m_orientation;

	// bullet physics objects
	std::vector<btRigidBody*> m_segments;
	std::vector<btConeTwistConstraint*> m_constraints;
	btCollisionShape *m_collisionShape;
	GlobalPhysics *m_physicsEngine;
};

