#pragma once
#include "PrecompiledHeaders.h"

#include "vector.h"

namespace modGeo {
	class interpolation {
	public:
		interpolation(void);
		~interpolation(void);

		std::vector<vector> mInterPoints;
		std::vector<vector> mBezierPoints;
		std::vector<double> mLineLengths;
		double mLineLengthSum;
		vector mFirstTangent;

		void addInterPoint(vector point);
		void addInterPoint(ci::Vec3f point);
		void moveInterPoint(int n, vector point);
		void moveInterPoint(int n, ci::Vec3f point);
		void removeLastInterPoint();
		void updateControlPoints();
		void setFirstTangent(ci::Vec3f Tangent);
		ci::Vec3f tangent(double t) const;
		ci::Vec3f normal(double t) const;
		ci::Vec3f binormal(double t) const;

		int getPointsLength() const;

		vector deCasteljau(int segmentNumber, double t) const;
		ci::Vec3f deCasteljauUniform(double t) const;
	};
}
