#pragma once
#include "PrecompiledHeaders.h"

namespace modGeo {
	class vector {
	public:
		vector(void);
		vector(double x, double y, double z);
		explicit vector(ci::Vec3f v);
		~vector(void);

		ci::Vec3f toVec3f();

		void zero();
		void fix();
		void normalize();
		friend vector oneThird(const vector &v1, const vector &v2);
		friend vector midPoint(const vector &v1, const vector &v2);
		friend double dot(const vector &v1, const vector &v2);
		friend vector cross(const vector &v1, const vector &v2);
		friend double distance(const vector &v1, const vector &v2);
		double length();
		double length2();
		friend std::ostream& operator<<(std::ostream &out, const vector &mat);
		double& operator[](int i);
		const double& operator[](int i) const;
		friend vector operator*(const vector &lhs, double a);
		friend vector operator/(const vector &lhs, double a);
		friend vector operator+(const vector &lhs, const vector &rhs);
		friend vector operator-(const vector &lhs, const vector &rhs);
		friend vector operator*(const vector &lhs, const vector &rhs);
		friend vector operator/(const vector &lhs, const vector &rhs);
		vector operator-() const;

		double tab[4];
	};
}
