#include "TextureGenerator.h"

void TextureGenerator::perlinNoiseTexture(gl::Texture& mTexture, int size){
    Perlin noise = Perlin(40); //TODO: change seed for constant
    float channelSize = (float)size;

    Channel channel = Channel8u(size, size);
    Channel::Iter iter = channel.getIter(channel.getBounds());
    float max_value = -1.0;
    float min_value = 10001.0;

    while(iter.line()){
        while(iter.pixel()){
            Vec2f current = iter.getPos();
            float value = 255.0F * noise.fBm(5 * current.x/channelSize, 5 * current.y/channelSize);
            if( value > max_value){
                max_value = value ;
            }
            if( value < min_value){
                min_value = value ;
            }
        }
    }

    iter = channel.getIter(channel.getBounds());
    while(iter.line()){
        while(iter.pixel()){
            Vec2f current = iter.getPos();
            float value = 255.0f * noise.fBm(5 * current.x/channelSize, 5 * current.y/channelSize);
            value = 255.0f * (value - min_value) / (max_value - min_value);
            iter.v() = (uint8_t)value;
        }
    }

    //for symmetry
    int half = size / 2;
    for(int i=channel.getWidth()/2; i<channel.getWidth(); ++i){
        for(int j=0; j<channel.getHeight(); ++j){
            channel.setValue(Vec2i(i,j), channel.getValue(Vec2i(channel.getWidth()-i, j)));
        }
    }

    mTexture = gl::Texture(channel);
}